Description

use as !{{backlinks}} or !{{backlinks(Foo)}}. sort-a hack-it-yourself for the fearless

#XXX insert at end of Definitions in lib/redmine/wiki_formatting/macros.rb, after other macroses

#XXX svild: part from child_pages, part from SearchController.index, part from render_page_hierarc

hy

      desc "shows backlinks to the/a wiki page. Example:\n\n  !{{backlinks}} or !{{backlinks(Foo)}

} " 

      macro :backlinks do |obj, args|

          title = nil

        if args.size > 0

          page = Wiki.find_page(args.first.to_s, :project => @project)

        elsif obj.is_a?(WikiContent) || obj.is_a?(WikiContent::Version)

          page = obj.page

            title = 'here'

        else

          raise 'With no argument, this macro can be called from wiki pages only.'

        end

        raise 'Page not found' if page.nil? || !User.current.allowed_to?(:view_wiki_pages, page.wi

ki.project)

        r,c = WikiPage.search( "[["+page.title, @project ,

          :all_words => true ,

          :titles_only => false

          #,:limit => 100,

          #,:offset => 0

          )

        title = page.pretty_title if title.nil?

        content = ''

          content << "links to " + title + ": " 

          #content << "<ul> " 

          r.each do |p|

            #content << "<li>" 

            content << link_to( h(p.pretty_title),

                                {     :controller => 'wiki', :action => 'show',

                                    :project_id => p.project, :id => p.title },

                               :title => nil)

            content << "\n" 

            #content << "</li>\n" 

          end

          #content << "</ul>\n" 

          content

      end

History

#1 - 2012-11-14 16:38 - Stanislav German-Evtushenko

Would be great to have backlinks in Redmine wiki!

#2 - 2013-11-30 14:58 - Josef  Čech
Hi. I've put the functionality into the plugin for those interested in the backlinks feature:

https://github.com/Yrwein/redmine_backlinks

In fact it's rewritten code above (we've used a modified version of the patch in previous versions of Redmine, but it was removed after upgrade) with

possibility to show backlinks on every wiki page without macro call.

#3 - 2016-05-10 10:53 - Paolo Crisafulli

+1

I would also love to have the possibility to search for backlinks in a subtree of a wiki.

#4 - 2018-07-19 03:24 - Go MAEDA

- Tracker changed from Defect to Feature
